<template>
    <div class="content-block">
        <city-choice-modal v-if="$interface.viewport === 'mobile'" @choice="setCity"></city-choice-modal>
        <div class="container">
            <div class="margin-top-50"></div>
            <div class="row">
                <div class="columns twelve central-column pos-block">
                    <div class="content">
                        <div class="header-block header-with-menu">

                            <h3 class="header">
                                <span class="back-arrow" @click="$router.back()" v-if="partnerId"></span>
                                {{category}}

                                <span class="link" style="border-bottom:1px dashed #198af2;"
                                      @click="$modal.show('choice-city')"
                                      v-if="$interface.viewport === 'mobile'">{{$installment.geo_type === 'geo' ? 'Партнеры рядом' : $installment.city}}
                            </span>
                            </h3>
                            <div class="pos-menu">
                                <input type="text" name="search" id="search" placeholder="Поиск партнеров"
                                       v-model="search"
                                       class="search"/>
                                <div class="lag"></div>
                                <div class="relative">
                                    <span class="clear_category" v-if="categorySlug"
                                          @click="$router.push({name: 'installment-partners'})"></span>
                                    <button class="pos-menu-button" id="pos-menu-button"
                                            @click.prevent.stop="toggleCategory"
                                            :class="{active: displayCategory, padding:categorySlug}"
                                    >
                                        {{category}}
                                    </button>
                                </div>
                                <div class="row menu" :class="{opened: displayCategory}" id="pos-menu">

                                    <router-link
                                            :to="{name: 'installment-partners', params: {id: `Category:${category.slug}`}}"
                                            class="item"
                                            :class="{selected: category.slug === categorySlug}"
                                            v-for="category in categories"
                                            :key="category.name">
                                        <img
                                                :src="`/lk/static/img/pos/partner-category/${category.img}.png`"
                                                alt=""/>
                                        {{category.name}}
                                    </router-link>

                                </div>
                            </div>
                            <div class="clear-fix-block"></div>
                        </div>
                        <div class="pos-partners-list">
                            <transition name="fade">
                                <div v-if="!partnerId" style="width: 100%;">
                                    <router-link :to="{name: 'installment-partners', params: {id: p.id}}"
                                                 :key="p.id"
                                                 v-for="p in partnerShops" class="item">
                                        <div class="image">
                                            <img :src="p.logo" :alt="p.name" class="partner_logo"/>
                                        </div>
                                        <h3 class="partner_name"
                                            v-tooltip.bottom="{content: p.name, classes: ['tooltip_pos']}">
                                            {{p.name}}</h3>
                                        <span>{{p.description}}</span>
                                    </router-link>
                                    <div v-if="!partnerShops.length">
                                        <div class="white-block warning-block">
                                            <div class="">
                                                <div v-if="$installment.location.lat && $installment.location.lon">
                                                    В категории <b>{{category}}</b> рядом с вами магазинов нет.
                                                </div>
                                                <div v-else-if="$installment.city">
                                                    В категории <b>{{category}}</b> в городе {{$installment.city}}
                                                    парнтеров нет.
                                                </div>
                                                <div v-else>
                                                    В категории <b>{{category}}</b> в городе магазинов нет.
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                                <div v-else style="width: 100%;">
                                    <partner-details :id="partnerId"></partner-details>
                                </div>
                            </transition>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

</template>

<script>
    import CityChoiceModal from '@/components/Modals/CityChoice';

    import partnerDetails from './Components/Partners/Details.vue';
    import DetailedInformation from './Components/DetailedInformation/index';
    import CategoryTag from './Components/CategoryTag/index';
    import ScrollBar from 'vue2-scrollbar';
    import config from '@/config';

    const BASE_URL = config.POS_BASE_URL;

    export default {
        name: 'installmentPartners',
        components: {
            CategoryTag,
            DetailedInformation,
            partnerDetails,
            ScrollBar,
            CityChoiceModal
        },
        data() {
            return {
                categories: [
                    // {name: 'Продукты', img: '1-1'},
                    {
                        name: 'Электроника',
                        img: '1-2',
                        slug: 'electronics'
                    },
                    {
                        name: 'Мебель',
                        img: '1-3',
                        slug: 'furniture'
                    },
                    {
                        name: 'Одежда',
                        img: '1-4',
                        slug: 'clothes'
                    },
                    {
                        name: 'Обувь',
                        img: '1-5',
                        slug: 'boots'
                    },
                    {
                        name: 'Путешествия',
                        img: '1-6',
                        slug: 'journeys'
                    },
                    {
                        name: 'Кафе и рестораны',
                        img: '2-1',
                        slug: 'cafes_and_restaurants'
                    },
                    {
                        name: 'Развлечения',
                        img: '2-2',
                        slug: 'entertainments',
                    },
                    {
                        name: 'Образование',
                        img: '2-3',
                        slug: 'education'
                    },
                    {
                        name: 'АЗС',
                        img: '2-4',
                        slug: 'petrol_station'
                    },
                    {
                        name: 'Страхование',
                        img: '2-5',
                        slug: 'insurance',
                    },
                    {
                        name: 'Зоотовары',
                        img: '2-6',
                        slug: 'pet_supplies',
                    },
                    {
                        name: 'Ремонт',
                        img: '3-1',
                        slug: 'repair',
                    },
                    {
                        name: 'Товары для детей',
                        img: '3-2',
                        slug: 'goods_for_children',
                    },
                    {
                        name: 'Авто',
                        img: '3-3',
                        slug: 'auto',
                    },
                    {
                        name: 'Красота и здоровье',
                        img: '3-4',
                        slug: 'beauty_and_health',
                    },
                    {
                        name: 'Спортивные товары и туризм',
                        img: '3-5',
                        slug: 'sport_and_tourism',
                    },
                    {
                        name: 'Ювелирные изделия',
                        img: '3-6',
                        slug: 'jewelry'
                    },
                ],
                /**
                 * Раскрыть список категорий
                 */
                displayCategory: false,
                /**
                 * Фильтр по имени партнера
                 */
                search: '',

                /**
                 * список партнеров
                 */
                partners: [],
                partnerId: 0,

            };
        },


        computed: {


            partnerShops() {
                return this.$installment.partnerShops.map((shop) => {
                    if (!shop.logo) {
                        shop.logo = '/lk/static/img/pos/partner/default.png';
                    }
                    return shop;
                });

            },

            list() {
                const list = this.partners;
                if (this.search) {

                }

                return list;
            },

            category() {
                if (this.categorySlug) {
                    const category = this.categories.find((category) => {
                        return category.slug === this.categorySlug;
                    });

                    if (category) {
                        return category.name;
                    } else {
                        return 'Все категории';
                    }
                }

                return 'Все категории';
            },

            categorySlug() {
                if (Number.isInteger(this.$route.params.id)) {
                    return;
                }

                if (this.$route.params.id && this.$route.params.id.startsWith('Category:')) {
                    return this.$route.params.id.split(':')[1];
                }
                return '';
            },

            cityName() {
                return this.$installment.location.lat && this.$installment.location.lon ? 'Партнеры рядом' : this.$installment.city;
            }
        },

        watch: {
            displayCategory(state) {
                console.warn('ds', state);
                this.$nextTick(() => {
                    if (state) {
                        document.addEventListener('click', this.hideCategoriesHandler, false);
                    } else {
                        document.removeEventListener('click', this.hideCategoriesHandler, false);
                    }
                })
            },

            '$route.params.id': {
                immediate: true,
                handler: function () {
                    this.loadPartners();
                }
            },

            '$installment.geo_fias_id': function () {
                this.loadPartners();
            },

            '$installment.geo_type': {
                deep: true,
                handler() {
                    this.loadPartners();
                }
            }
        },

        created() {
            if (Number.isInteger(this.$route.params.id)) {
                this.partnerId = this.$route.params.id;
            }

            if (this.$interface.viewport === 'mobile' && (!this.$installment.location.lat || !this.$installment.city)) {
                this.$store.commit('SET_POS_FIAS', {
                    'city': 'Москва',
                    'city_fias_id': '0c5b2444-70a0-4932-980c-b4dc0d3f02b5'
                });
            }
        },

        methods: {
            toggleCategory () {
                this.displayCategory = !this.displayCategory;
            },
            setCity(id) {
                if (id === 'moscow') {
                    id = {
                        "city":"Москва",
                        "city_fias_id":"0c5b2444-70a0-4932-980c-b4dc0d3f02b5"
                    };
                }
                this.$store.commit('SET_POS_FIAS', id);

                this.$modal.hide('choice-city');
            },
            hideCategoriesHandler({ target }) {
                if (!target.closest('#pos-menu')) {
                    this.displayCategory = false;
                }
            },

            loadPartners(id) {
                if (!id) id = this.$route.params.id;

                if (/^[0-9]+$/.test(id)) {
                    this.partnerId = parseInt(id);
                } else if (!id) {
                    this.partnerId = '';
                }

                this.$nextTick(() => {
                    if (this.displayCategory) {
                        this.displayCategory = false;
                        document.removeEventListener('click', this.hideCategoriesHandler, false);
                    }
                })

                if (!this.$route.params.id) {
                    this.AJAX_LOADING({
                        waitingTitle: 'Загрузка магазинов',
                    });

                    this.$helpers.noscroll(true);
                    this.$store.dispatch('GET_INSTALLMENT_PARTNERS')
                        .finally(() => {
                            this.AJAX_LOADING(false);
                            this.$helpers.noscroll(false);
                        });

                    return;
                }

                const category = this.categories.find((category) => {
                    return category.slug === this.categorySlug;
                });

                if (category) {
                    this.AJAX_LOADING({
                        waitingTitle: 'Загрузка магазинов',
                    });

                    this.$helpers.noscroll(true);
                    this.$backend.getData(`v2/merchant?category=${category.slug}&city_fias_id=${this.$installment.city_fias_id}`, BASE_URL)
                        .then(({ data }) => {
                            console.log(data);
                            this.$store.commit('SET_INSTALLMENT_PARTNERS', data.data);
                        })
                        .catch((e) => {
                            this.$toastr.error('Не удалось загрузить магазины', 'Ошибка');
                        })
                        .finally(() => {
                            this.AJAX_LOADING(false);
                            this.$helpers.noscroll(false);
                        });
                }
            }
        }
    };
</script>

<style lang="scss">
    a {
        &.item.selected {
            font-weight: bold !important;
        }
    }

    .pos-block {
        span.back-arrow {
            background: url(/lk/static/img/icons/left-year-arrow.png);
            background-size: cover;
            width: 24px;height:24px;
            display: inline-block;
            margin-right: 16px;
            position: relative;
            top: 3px;
        }
        & .menu.opened {
            display: flex !important;
        }
    }

    .pos-menu {
        & .clear_category {
            display: inline-block;
            position: relative;
            top: 10px;
            left: 60px;

            background-repeat: no-repeat;
            background-position: 50% 10px;
            cursor: pointer;
            z-index: 1;
            background: url(/lk/static/img/icons/close.png) no-repeat 50% 10px;
            width: 60px;
            height: 30px;

        }
    }

    .pos-menu-button {
        &.padding {
            padding-left: 60px !important;
        }
    }

    .my-scrollbar {
        width: 100%;
    }

    .vue-scrollbar-transition {
        right: 1px;
    }

    .vue-scrollbar-transition, .vue-scrollbar__scrollbar-horizontal, .vue-scrollbar__scrollbar-vertical {
        transition: all .5s ease;
    }

    .vue-scrollbar-transition--scrollbar {
        transition: opacity .5s linear;
    }

    .vue-scrollbar__wrapper {
        margin: 0 auto;
        overflow: hidden;
        position: relative;
        background: #fff
    }

    .vue-scrollbar__wrapper:hover .vue-scrollbar__scrollbar-horizontal, .vue-scrollbar__wrapper:hover .vue-scrollbar__scrollbar-vertical {
        opacity: 1;
    }

    .vue-scrollbar__scrollbar-horizontal, .vue-scrollbar__scrollbar-vertical {
        opacity: .3;
        position: absolute;
        background: transparent
    }

    .vue-scrollbar__scrollbar-horizontal, .vue-scrollbar__scrollbar-vertical {
        background: #e8f0fd;
    }

    .vue-scrollbar__scrollbar-horizontal .scrollbar, .vue-scrollbar__scrollbar-vertical .scrollbar {
        position: relative;
        background: #4d92e3;
        border-radius: 3px;
        cursor: default
    }

    .vue-scrollbar__scrollbar-vertical {
        width: 3px;
        height: 100%;
        top: 0;
        right: 2px;
    }

    .vue-scrollbar__scrollbar-vertical .scrollbar {
        width: 5px
    }

    .vue-scrollbar__scrollbar-horizontal {
        height: 10px;
        width: 100%;
        bottom: 0;
        right: 0
    }

    .vue-scrollbar__scrollbar-horizontal .scrollbar {
        height: 10px
    }
</style>
